local Object = require("lib.classic")
local Button = Object:extend()

function Button:new(name)
    self.name = name
    self.pressed = false
    self.wasPressed = false
end

function Button:reset()
    self.pressed = false
    self.wasPressed = false
end

function Button:intValue()
    return self.pressed and 1 or 0
end

function Button:press()
    if not self.pressed then
        self.pressed = true
        self.wasPressed = false
    end
end

function Button:release()
    if self.pressed then
        self.pressed = false
        self.wasPressed = true
    end
end

function Button:update()
    self.wasPressed = self.pressed
end

function Button:justPressed()
    return self.wasPressed == false and self.pressed == true
end

function Button:justReleased()
    return self.wasPressed == true and self.pressed == false
end

return Button