local Object = require("lib.classic")
local Camera = Object:extend()

function Camera:new(w, h)
    self.pos = {x=0,y=0}
    self.smoothX = 0
    self.smoothY = 0
    self.prevX = 0
    self.prevY = 0
    self.width = w
    self.half_width = w / 2
    self.height = h
    self.half_height = h / 2
    self.min_x = -999999
    self.min_y = -999999
    self.max_x = 999999
    self.max_y = 999999
end

function Camera:attach(xscale, yscale)
    xscale = xscale or 1
    yscale = yscale or 1
    love.graphics.push()
    local tlx, tly = self:topLeft()
    love.graphics.translate(round(-tlx*DRAW_SCALE*xscale), round(-tly*DRAW_SCALE*yscale))
end

function Camera:detach()
    love.graphics.pop()
end

function Camera:topLeft()
    return self.smoothX - self.half_width, self.smoothY - self.half_height
end

function Camera:getRect()
    return self.smoothX - self.half_width, self.smoothY - self.half_height, self.width, self.height
end

function Camera:setPosition(newX, newY)
    self.pos.x = (math.max(self.min_x + self.half_width, math.min(self.max_x - self.half_width, newX)))
    self.pos.y = (math.max(self.min_y + self.half_height, math.min(self.max_y - self.half_height, newY)))
end

return Camera