local Object = require("lib.classic")

local Entity = Object:extend()
function Entity:new(x, y, data)
    x = x or 0
    y = y or 0
    self.active = true
    self.position = {x=x, y=y, sx=x, sy=y, px=x, py=y}
    self.velocity = {x=0, y=0}
    self.extents = {w=0, h=0}
    self.animation = {}
    self.frameTimer = 0
    self.frame = 1
    self.flipH = false
    self.flipV = false
    self.animationRunning = true
    self.visible = true
    
    if data then
        for k,v in pairs(data) do
            self[k] = v
        end
    end

    if self.init then
        self.init(self)
    end
end

function Entity:playAnimation(animation)
    self.animation = animation
    self.frameTimer = 0
    self.frame = 1
    self.animationRunning = true
end

function Entity:pauseAnimation() 
    self.animationRunning = false
end
    
function Entity:unpauseAnimation() 
    self.animationRunning = true
end

function Entity:overlapsWith(other)
    local w = self.extents.w + other.extents.w
    local h = self.extents.h + other.extents.h

    return math.abs(other.position.x - self.position.x) < w and math.abs(other.position.y - self.position.y) < h 
end

return Entity