local Object = require("lib.classic")
local ObjectPool = Object:extend()

function ObjectPool:new(t, count)
    self.objs = {}
    self.cache = {}
    local id=0

    for i=1,count do
        local obj = t()
        obj.pid = id
        obj.pool = self
        local w = {obj=obj, alive=false}
        table.insert(self.objs, w)
        self.cache[obj.pid] = w
        id = id + 1
    end
end

function ObjectPool:reserve()
    for i=1,#self.objs do
        local v = self.objs[i]
        if (v.alive == false) then 
            v.alive = true
            return v.obj
        end
    end
    return nil
end

function ObjectPool:release(obj)
    self.cache[obj.pid].alive = false
end

function ObjectPool:reservedCount()
    local i = 0
    for _, obj in ipairs(self.objs)  do
        if (obj.alive) then 
            i = i + 1
        end
    end
    return i
end

function ObjectPool:freeCount()
    local i = 0
    for _, obj in ipairs(self.objs)  do
        if (not obj.alive) then 
            i = i + 1
        end
    end
    return i
end

return ObjectPool