local Object = require("lib.classic")
local PooledSource = Object:extend()

function PooledSource:new(path, volume, count)
    self.path = path
    self.volume = volume
    self.source = love.audio.newSource(self.path, "static")
    self.clones = {}

    for i =1,count do
        table.insert(self.clones, self.source:clone())
    end
end

function PooledSource:play()
    for i=1,#self.clones do
        local src = self.clones[i]
        if src:isPlaying() == false then
            SoundManager:playSfx(src, self.volume)
            return
        end
    end
end

return PooledSource