local TextureAtlas = require("framework.texture_atlas")

local Assets = {}

local TileMap = require("framework.tilemap")

textures = {}
textures.atlas = love.graphics.newImage("assets/gfx/atlas.png")
textures.bambooBackground = love.graphics.newImage("assets/gfx/bg-bamboo.png")
textures.trunksBackground = love.graphics.newImage("assets/gfx/bg-trunks.png")
textures.vinesBackground = love.graphics.newImage("assets/gfx/bg-vines.png")
textures.lightBackground = love.graphics.newImage("assets/gfx/bg-light.png")
textures.titleBackground = love.graphics.newImage("assets/gfx/title.png")

atlases = {}
atlases.debugTileset = TextureAtlas(textures.atlas, 64, 64)
atlases.player = TextureAtlas(textures.atlas, 13, 2, 0, 64, 208, 32)
atlases.playerAttack = TextureAtlas(textures.atlas, 1, 1, 8, 16, 8, 8)
atlases.redNinja = TextureAtlas(textures.atlas, 7, 1, 0, 96, 112, 16)
atlases.enemy1 = TextureAtlas(textures.atlas, 4, 1, 0, 112, 64, 16)
atlases.boss = TextureAtlas(textures.atlas, 8, 1, 0, 128, 256, 32)
atlases.flame = TextureAtlas(textures.atlas, 2, 1, 80, 112, 16, 8)
atlases.flash = TextureAtlas(textures.atlas, 7, 1, 0, 52, 56, 8)

atlases.font = TextureAtlas(textures.atlas, 26, 3, 0, 192, 104, 24)
atlases.digits = TextureAtlas(textures.atlas, 10, 0, 24, 108, 40, 5)

hud = {
    heart = TextureAtlas(textures.atlas, 1, 1, 0, 44, 5,5),
    energy = TextureAtlas(textures.atlas, 2, 1, 5, 44, 2,5),
    life = TextureAtlas(textures.atlas, 1,1, 8, 44, 6, 5),
    digits = TextureAtlas(textures.atlas,10,1,64,0,40,5)
}

tilemaps = {}
tilemaps.tutorial = TileMap(atlases.debugTileset, "assets/tilemaps/tutorial.lua")
tilemaps.level1 = TileMap(atlases.debugTileset, "assets/tilemaps/level1.lua")
tilemaps.level2 = TileMap(atlases.debugTileset, "assets/tilemaps/level2.lua")
tilemaps.level3 = TileMap(atlases.debugTileset, "assets/tilemaps/level3.lua")
tilemaps.boss = TileMap(atlases.debugTileset, "assets/tilemaps/boss.lua")


local PooledSource = require("framework.pooled_source")
sfx = {}
sfx.jump = PooledSource("assets/sfx/jump.wav", 0.2, 2)
sfx.land = PooledSource("assets/sfx/land.wav", 0.2, 2)
sfx.slash = PooledSource("assets/sfx/slash.wav", 0.7, 3)
sfx.playerHit = PooledSource("assets/sfx/player_hit.wav", 0.9, 2)
sfx.playerDie = PooledSource("assets/sfx/player_die.wav", 0.9, 1)
sfx.enemyDie = PooledSource("assets/sfx/enemy_die.wav", 0.9, 3)

music = {}
music.backgroundMusic = {source = love.audio.newSource("assets/music/music_zapsplat_game_music_medium_action_electronic_techno_style_fun_020.mp3", "stream"),volume=0.6}
music.bossMusic = {source = love.audio.newSource("assets/music/music_zapsplat_game_music_action_energy_dramatic_drums_heavy_synth_010.mp3", "stream"),volume=0.6}

return {
    textures = textures,
    atlases = atlases,
    tilemaps = tilemaps, 
    hud = hud,
    sfx = sfx,
    music = music
}