local Entity = require("framework.entity")

return function(player)
    return Entity(player.x, player.y, {
        t = 0,
        active = false,
        extents = {w=3, h=2},
        offset = {x = 6, y = -1},
        update = function(sa, gameLogic, dt)
            sa.position.x = player.position.x+ sa.offset.x*sa.dir
            sa.position.y = player.position.y
            sa.t = sa.t - 1
            if sa.t == 0 then
                sa.active = false
            end
        end,

        attack = function(self, x, y, duration, dir)
            self.dir = dir
            self.position.x = x + self.offset.x*dir
            self.position.y = y
            self.t = duration
            self.active = true
        end,

        cancel = function(self)
            self.active = false
        end
    })
end