local Background = require("framework.background")
local Level = require("framework.level")
local Enemies = require("game.entities.enemies")

local levels = {}

local function defineLevel(data)
    table.insert(levels, Level(data))
    return data
end

defineLevel({
    name = "Level 1",
    tilemap = Assets.tilemaps.tutorial,
    music = Assets.music.backgroundMusic,
    backgrounds = {
        Background(Assets.textures.lightBackground, 0.125, 0),
        Background(Assets.textures.bambooBackground, 0.5, 0),
        Background(Assets.textures.trunksBackground, 0.75, 0)
    }
})

defineLevel({
    name = "Level 2",
    tilemap = Assets.tilemaps.level2,
    music = Assets.music.backgroundMusic,
    backgrounds = {
        Background(Assets.textures.lightBackground, 0.125, 0),
        Background(Assets.textures.bambooBackground, 0.5, 0),
        Background(Assets.textures.trunksBackground, 0.75, 0)
    }
})

defineLevel({
    name = "Level 3",
    tilemap = Assets.tilemaps.level3,
    music = Assets.music.backgroundMusic,
    backgrounds = {
        Background(Assets.textures.lightBackground, 0.125, 0),
        Background(Assets.textures.bambooBackground, 0.5, 0),
        Background(Assets.textures.trunksBackground, 0.75, 0)
    }
})

defineLevel({
    name = "Boss",
    tilemap = Assets.tilemaps.boss,
    music = Assets.music.bossMusic,
    backgrounds = {
        Background(Assets.textures.lightBackground, 0.125, 0),
        Background(Assets.textures.bambooBackground, 0.5, 0),
        Background(Assets.textures.trunksBackground, 0.75, 0)
    },

    start = function(self, gameLogic)
        gameLogic:addEnemy(Enemies.boss(10, 10))
    end,

    checkEndCondition = function(self, gameLogic)
        return #gameLogic.enemies == 0 
    end
})

return levels

