local BaseState = require("states.base_state")



local GameBeatState = BaseState:extend()

function GameBeatState:new()
    self.super.new(self)
    self.inputState = "menu"
    
end

function GameBeatState:enter(previous, levelNumber)
    self.levelNumber = levelNumber
    UI:clear()
end

function GameBeatState:onPressed_menu_left()
    UI:onPressed_menu_left()
end

function GameBeatState:onPressed_menu_right()
    UI:onPressed_menu_right()
end

function GameBeatState:onPressed_menu_accept()
    UI:onPressed_menu_accept()
    Events.switchState(States.Title)
end

function GameBeatState:onPressed_menu_cancel()
    UI:onPressed_menu_cancel()
end

function GameBeatState:update(dt)
    UI:update(dt)
    self.super.update(self, dt)
end

function GameBeatState:draw()
    love.graphics.setCanvas(viewportCanvas)
    love.graphics.clear()
    
    bmpPrint("       Thanks", Assets.atlases.font,0, DRAW_HEIGHT/2 - 8)
    bmpPrint("    for playing!", Assets.atlases.font,0, (DRAW_HEIGHT/2 - 8) + 10)
    
    UI:draw()
end

return GameBeatState()