local BaseState = require("states.base_state")

local GameOverState = BaseState:extend()

function GameOverState:new()
    self.super.new(self)
    self.inputState = "menu"
    
end

function GameOverState:enter(previous, levelNumber, ...)
    self.t = 0
    self.levelNumber = levelNumber
    self.data = {...}
    UI:clear()
end

function GameOverState:onPressed_menu_left()
    UI:onPressed_menu_left()
end

function GameOverState:onPressed_menu_right()
    UI:onPressed_menu_right()
end

function GameOverState:onPressed_menu_accept()
    UI:onPressed_menu_accept()
    if self.t > 0.25 then
        Events.switchState(States.Title)
    end

end

function GameOverState:onPressed_menu_cancel()
    UI:onPressed_menu_cancel()
end

function GameOverState:update(dt)
    UI:update(dt)
    self.super.update(self, dt)

    self.t = self.t + dt
    if self.t >= 5 then
        Events.switchState(States.Title)
    end
end

function GameOverState:draw()
    love.graphics.setCanvas(viewportCanvas)
    love.graphics.clear()
    local level =Levels[self.levelNumber]

    bmpPrint("Game Over", Assets.atlases.font, 10, DRAW_HEIGHT/2 - 8)

    UI:draw()
end

return GameOverState()