local BaseState = require("states.base_state")
local Camera = require("framework.camera")
local GameLogic = require("game.game_logic")
local TileMap = require("framework.tilemap")
local GameState = BaseState:extend()

function GameState:new()
    self.super.new(self)
    self.timestep = TIMESTEP
    self.dtAcc = 0
 
    self.camera = Camera(PLAY_WIDTH, PLAY_HEIGHT)
end

function GameState:enter(state, level, session)
    self.super.enter(self)
    self.gameLogic = GameLogic(level, session)
end

function GameState:update(dt)
    self.dtAcc = self.dtAcc + dt
 
    local steps = math.floor(self.dtAcc/self.timestep)
    
    if steps > 0 then
        self.dtAcc = self.dtAcc - (steps * self.timestep)
    end

    local alpha = self.dtAcc / self.timestep
    for i=1,steps do
        
        self.gameLogic:resetSmoothStates()
        
        self.gameLogic:update(self.timestep)
        self.super.update(self, timestep)
    end

    self.gameLogic:smoothStates(alpha)
   
end

function GameState:draw()
     -- draw play area
    
    love.graphics.setCanvas(viewportCanvas)
    love.graphics.clear()
    
    self.gameLogic:draw()
    
    -- drawToViewport(drawCanvas, xOff, yOff)   
end

return GameState()