local BaseState = require("states.base_state")



local LevelIntroState = BaseState:extend()

function LevelIntroState:new()
    self.super.new(self)
    self.inputState = "menu"
    
end

function LevelIntroState:enter(previous, levelNumber, ...)
    self.t = 0
    self.levelNumber = levelNumber
    self.data = {...}
    UI:clear()
    SoundManager:stopMusic()
end

function LevelIntroState:onPressed_menu_left()
    UI:onPressed_menu_left()
end

function LevelIntroState:onPressed_menu_right()
    UI:onPressed_menu_right()

end

function LevelIntroState:onPressed_menu_accept()
    UI:onPressed_menu_accept()
    if self.t > 0.25 then
        Events.switchState(States.Game, self.levelNumber, unpack(self.data))
    end
end

function LevelIntroState:onPressed_menu_cancel()
    UI:onPressed_menu_cancel()
end

function LevelIntroState:update(dt)
    UI:update(dt)
    self.super.update(self, dt)

    self.t = self.t + dt
    if self.t >= 2 then
        Events.switchState(States.Game, self.levelNumber, unpack(self.data))
    end
end

function LevelIntroState:draw()
    love.graphics.setCanvas(viewportCanvas)
    love.graphics.clear()
    local level =Levels[self.levelNumber]

    bmpPrint(level.name, Assets.atlases.font, 10, DRAW_HEIGHT/2 - 8)
    -- centreText(level.name,0, DRAW_HEIGHT/2 - 8)
    
    UI:draw()

    
  
    
    -- love.graphics.draw(States.Game.hudCanvas, 0, 0, 0, DRAW_SCALE, DRAW_SCALE)
end

return LevelIntroState()