local BaseState = require("states.base_state")
local PlaySession = require("game.session")


local TitleState = BaseState:extend()

function TitleState:new()
    self.super.new(self)
    self.inputState = "menu"
    
end

function TitleState:enter()
    UI:clear()
    SoundManager:playMusic(Assets.music.bossMusic)
end

function TitleState:onPressed_menu_left()
    UI:onPressed_menu_left()
end

function TitleState:onPressed_menu_right()
    UI:onPressed_menu_right()

end

function TitleState:onPressed_menu_accept()
    UI:onPressed_menu_accept()
    Events.switchState(States.LevelIntro, 1, PlaySession())
end

function TitleState:onPressed_menu_cancel()
    UI:onPressed_menu_cancel()
end

function TitleState:update(dt)
    UI:update(dt)
    self.super.update(self, dt)
end

function TitleState:draw()
    love.graphics.setCanvas(drawCanvas)
    love.graphics.clear()
    
    
    
    
    UI:draw()

    drawToViewport(drawCanvas)

    love.graphics.setCanvas(viewportCanvas)
    love.graphics.draw(Assets.textures.titleBackground, 0,0, 0, DRAW_SCALE, DRAW_SCALE)
    -- love.graphics.setColor(1,0,0,1)
    love.graphics.setColor(25/255,25/255,27/255,1)
    love.graphics.setColor(0,0,0,0.5)
    love.graphics.rectangle("fill",6*DRAW_SCALE,44*DRAW_SCALE,51*DRAW_SCALE,16*DRAW_SCALE)
    love.graphics.setColor(242/255,240/255,229/255,1)
    bmpPrint("Press Button", Assets.atlases.font, 8, 46)
    bmpPrint("to Start", Assets.atlases.font, 16, 52)
    love.graphics.setColor(1,1,1,1)
    -- love.graphics.draw(States.Game.hudCanvas, 0, 0, 0, DRAW_SCALE, DRAW_SCALE)
end

return TitleState()