local Object = require("lib.classic")
local Stack = require("framework.stack")

local UI = Object:extend()

function UI:new()
    self.stack = Stack()
end

function UI:push(screen)
    self.stack:push(screen)
end

function UI:pop()
    self.stack:pop()
end

function UI:set(screen)
    self.stack:clear()
    self.stack:push(screen)
end

function UI:clear()
    self.stack:clear()
end

function UI:update(dt)
    local s = self.stack:head()
    if s and s.update then
        s:update(dt)
    end
end

function UI:draw()
    local s = self.stack:head()
    if s and s.draw then
        s:draw()
    end
end

function UI:onPressed_menu_left()
    local s  =self.stack:head()
    if s and s["onPressed_menu_left"] then
        s["onPressed_menu_left"](s)
    end
end

function UI:onPressed_menu_right()
    local s  =self.stack:head()
    if s and s["onPressed_menu_right"] then
        s["onPressed_menu_right"](s)
    end

end

function UI:onPressed_menu_accept()
    local s  =self.stack:head()
    if s and s["onPressed_menu_accept"] then
        s["onPressed_menu_accept"](s)
    end
end

function UI:onPressed_menu_cancel()
    local s  =self.stack:head()
    if s and s["onPressed_menu_cancel"] then
        s["onPressed_menu_cancel"](s)
    end
end

return UI()